# Uppsala University - Algorithms and Data Structures 1, 1DL210
# Copyright (c) 2020 Henrik Alfken(Schulze), Neethu Joseph, Hooman Asadian, Sarbojit Das
# Assignment 2 - Implementation of Sorting Algorithms
import os
import array
import sys
import time #import time to calculate running time


# Heapsort:
def heapsort(a):
    N = n = len(a)      # N = array size, n = heap size
    buildMaxHeap(a,N)
    for i in range(N-1,0,-1):
        swap(a,i,0)
        n -= 1          # decrement the heap size - disregard the last element!
        maxHeapify(a,0,n)

def buildMaxHeap(a,n):
    # n = heap size
    for i in range(int(n/2-1),-1,-1):
        maxHeapify(a,i,n)

def swap(a,i,j):
    temp = a[j]
    a[j] = a[i]
    a[i] = temp

def maxHeapify(a,i,n):
    # n = heap size
    l = 2*i +1
    r = l + 1
    if l < n and a[l] > a[i]:
        i_max = l
    else:
        i_max = i
    if r < n and a[r] > a[i_max]:
        i_max = r
    if i_max != i:
        swap(a, i, i_max)
        maxHeapify(a,i_max,n)


# This is the function to verify your implemented sorting algorithm
# You need to change it a bit to call your sorting algorithm
def test():
    # Check if nums.txt exists:
    if not os.path.exists('nums.txt'):
        print("First create nums.txt")
        sys.exit(0)

    # Read the content of nums.txt into an array, 'FH' is short for File Handle:
    numsFH = open('nums.txt', 'r')
    a = []
    for line in numsFH:
        a.append(int(str.strip(line)))

    # Sort the array using heapsortRecursive and calculate running time:
    start=time.time()
    heapsort(a)    # You need to change here to call your sorting algorithm
    end=time.time()
    print("heapsortRecursive running time:   ",end-start)
    numsFH.close()
    
    # Output heap-sorted.txt:
    nums_sortedFH = open('heap-sorted.txt', 'w')
    for element in a:
        nums_sortedFH.write(str(element) + "\n")
    # nums_sortedFH.write("100\n")

    numsFH.close()
    nums_sortedFH.close()

    # Compare 'heap-sorted.txt' with sorting by the operating system, 'nums_ref.txt':
    os.system('sort -n nums.txt > nums_ref.txt')
    ret = os.system('diff heap-sorted.txt nums_ref.txt > tmp.txt')

    # Tell the user whether your sorting succeded or failed:
    if int(ret) == 0:
        print("Sorted!")
    if int(ret) != 0:
        print("Not sorted!")

# python heapsortRecursive.py runs test
if __name__ == "__main__":
    test()
