# Uppsala University - Algorithms and Data Structures 1, 1DL210
# Copyright (c) 2020 Henrik Alfken(Schulze), Neethu Joseph, Hooman Asadian, Sarbojit Das
# Assignment 2 - Implementation of Sorting Algorithms
import os
import array
import sys
import time #import time to calculate running time

# Insertion Sort:
def insertionsort(a):
    n = len(a)
    for j in range(1, n):
        key = a[j]
        i = j
        while i>0 and a[i-1]>key:
            a[i] = a[i-1]
            i = i-1
        a[i] = key


# This is the function to verify your implemented sorting algorithm
# You need to change it a bit to call your sorting algorithm
def test():
    # Check if nums.txt exists:
    if not os.path.exists('nums.txt'):
        print("First create nums.txt")
        sys.exit(0)

    # Read the content of nums.txt into an array, 'FH' is short for File Handle:
    numsFH = open('nums.txt', 'r')
    a = []
    for line in numsFH:
        a.append(int(str.strip(line)))

    # Sort the array using insertionsort and calculate running time:
    start=time.time()
    insertionsort(a)    # You need to change here to call your sorting algorithm
    end=time.time()
    print("insertionsort running time:   ",end-start)
    numsFH.close()
    
    # Output insertion-sorted.txt:
    nums_sortedFH = open('insertion-sorted.txt', 'w')
    for element in a:
        nums_sortedFH.write(str(element) + "\n")
    # nums_sortedFH.write("100\n")

    numsFH.close()
    nums_sortedFH.close()

    # Compare 'insertion-sorted.txt' with sorting by the operating system, 'nums_ref.txt':
    os.system('sort -n nums.txt > nums_ref.txt')
    ret = os.system('diff insertion-sorted.txt nums_ref.txt > tmp.txt')

    # Tell the user whether your sorting succeded or failed:
    if int(ret) == 0:
        print("Sorted!")
    if int(ret) != 0:
        print("Not sorted!")

# python insertionsort.py runs test
if __name__ == "__main__":
    test()
