# Uppsala University - Algorithms and Data Structures 1, 1DL210
# Copyright (c) 2020 Henrik Alfken(Schulze), Neethu Joseph, Hooman Asadian, Sarbojit Das
# Assignment 2 - Implementation of Sorting Algorithms
import os
import array
import sys
import time #import time to calculate running time


# Quicksort:
def quicksort(a):
    n = len(a)
    quicksortRecursive(a, 0, n-1)

def quicksortRecursive(a, p, r):
    if p < r:
        q = partition(a, p, r)
        quicksortRecursive(a, p, q-1)
        quicksortRecursive(a, q+1, r)

def partition(a, p, r):
    x = a[r]
    i = p - 1
    for j in range(p, r):
        if x >= a[j]:
            i += 1
            swap(a, i, j)
    swap(a, i+1, r)
    return i+1

def swap(a, i, j):
    temp = a[j]
    a[j] = a[i]
    a[i] = temp


# This is the function to verify your implemented sorting algorithm
# You need to change it a bit to call your sorting algorithm
def test():
    # Check if nums.txt exists:
    if not os.path.exists('nums.txt'):
        print("First create nums.txt")
        sys.exit(0)

    # Read the content of nums.txt into an array, 'FH' is short for File Handle:
    numsFH = open('nums.txt', 'r')
    a = []
    for line in numsFH:
        a.append(int(str.strip(line)))

    # Sort the array using quicksortRecursive and calculate running time:
    start=time.time()
    quicksort(a)    # You need to change here to call your sorting algorithm
    end=time.time()
    print("quicksortRecursive running time:   ",end-start)
    numsFH.close()
    
    # Output quick-sorted.txt:
    nums_sortedFH = open('quick-sorted.txt', 'w')
    for element in a:
        nums_sortedFH.write(str(element) + "\n")
    # nums_sortedFH.write("100\n")

    numsFH.close()
    nums_sortedFH.close()

    # Compare 'quick-sorted.txt' with sorting by the operating system, 'nums_ref.txt':
    os.system('sort -n nums.txt > nums_ref.txt')
    ret = os.system('diff quick-sorted.txt nums_ref.txt > tmp.txt')

    # Tell the user whether your sorting succeded or failed:
    if int(ret) == 0:
        print("Sorted!")
    if int(ret) != 0:
        print("Not sorted!")

# python quicksortRecursive.py runs test
if __name__ == "__main__":
    test()
